d("paymentPOView",['util', 'paymentPOModel'], function(UTIL, paymentPOModel) {

    return {
        extendPaymentPOView: function() {
            let response = {};
            response['success'] = false;
            response['message'] = CCRZ.pagevars.pageLabels.ALTB2B_po_uploadWarning;
            CCRZ.views.paymentPOView = CCRZ.CloudCrazeView.extend({
                viewName: "paymentPOView",
                managedSubView: true,
                templateDesktop: CCRZ.util.template(CCRZ.uiProperties.paymentPOView.desktop.tmpl),
                templatePhone: CCRZ.util.template(CCRZ.uiProperties.paymentPOView.desktop.tmpl),
                init: function(options) {
                    this.selector = options.selector;
                    this.render();
                    CCRZ.pubSub.trigger('action:paymentViewInit', this);
                },
                parentPreRender: function() {
                    //Look for the instantiated iframe
                    //Detach it from the DOM
                    //Re-render the view but dont create the iframe
                    //Re-attach the iframe as appropriate in the rendered view
                },
                renderDesktop: function() {
                    this.setElement(this.selector);
                    this.data = {};
                    this.$el.html(this.templateDesktop(this.data));
                },
                renderPhone: function() {
                    this.setElement(this.selector);
                    this.data = {};
                    this.$el.html(this.templatePhone(this.data));
                },
                events : {
                    'click #submitPOBtn' : 'handleSubmit',
                    'change #termsdisclaimer' : 'handleChangeTerms',
                    'change #po-file' : 'handleFileChange',
                },
                handleSubmit : function(event){
                    let _this = this;
                    UTIL.showLoader();
                    //po field
                    let orderNumber = $('#orderNumber').val(), comments = $('#comments').val();
                    let isCheck = $('.cc_tc_terms').is(':checked');
                    if(!isCheck){
                        CCRZ.pubSub.trigger("pageMessage", CCRZ.createPageMessage('INFO', "storedpayment-messagingSection-Info", CCRZ.processPageLabelMap('KFB2B_Checkout_TermsError').toString()));
                        $('html, body').animate({
                            'scrollTop' : $(".storedpayment-messagingSection-Info").position().top
                        });
                        setTimeout(function(){
                            $('.storedpayment-messagingSection-Info').css('display', 'none');
                        }, 5000);
                        UTIL.hideLoader();
                        return;
                    }
                    if(orderNumber != ''){
                        _this.processPOPayment(orderNumber,comments, false, _this);
                    } else {
                        CCRZ.pubSub.trigger("pageMessage", CCRZ.createPageMessage('ERROR', "errorMessage-PO", CCRZ.processPageLabelMap('KFB2B_checkout_requiredError').toString()));
                        $('html, body').animate({
                            'scrollTop' : $(".errorMessage-PO").position().top
                        });
                        setTimeout(function(){
                            $('.errorMessage-PO').css('display', 'none');
                        }, 5000);
                        UTIL.hideLoader();
                    }
                },
                processPOPayment : function(poNumber,poComments, savePayment,_this){
                    let paymentObject = {
                        'accountNumber': poNumber,
                        'saveAsStoredPayment': savePayment,
                        'displayName': "",
                        'accountType': "po",
                        'comments' : poComments
                    }
                    _this.processTransactionPayment(paymentObject);
                },
                processTransactionPayment : function(transactionPayment){
                    CCRZ.pubSub.trigger('action:processPayment', transactionPayment);
                },
                displayErrorMsg : function(){
                    $.alert({
                        title: document.getElementById('poErrorHeading').value,
                        content: document.getElementById('poErrorMsg').value
                    });
                    $('#sidebarBackdropCustom').addClass('hide');
                },
                removePOFileValidation: function(poFile, poFileErrTxt){
                    poFileErrTxt.innerText = '';
                    poFile.style.border = '0px';
                },
                addPOFileValidation: function(poFile, poFileErrTxt, message){
                    poFile.style.border = '1px solid #c9341c';
                    poFileErrTxt.innerText = message;
                },
            });
            CCRZ.pubSub.trigger('action:paymentViewReady', 'po', function(options) {
                //need som info cart ID
                CCRZ.payment = CCRZ.payment || {
                    views: {}
                };
                CCRZ.payment.views.po = new CCRZ.views.paymentPOView({
                    model: new paymentPOModel(),
                    selector: options.selector
                });
            });
        } 
    }
});